Bug 1025601 - Review Request: python-pypump - Python Pump.io library
Review Request: python-pypump - Python Pump.io library
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Mario Blättermann
Fedora Extras Quality Assurance
:
Depends On: 1025367
Blocks:
  Show dependency treegraph
 
Reported: 2013-10-31 23:54 EDT by Ralph Bean
Modified: 2014-02-18 08:46 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-01-27 13:55:20 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
mario.blaettermann: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Ralph Bean 2013-10-31 23:54:07 EDT
Spec URL: http://ralph.fedorapeople.org//python-pypump.spec
SRPM URL: http://ralph.fedorapeople.org//python-pypump-0.4-1.fc19.src.rpm

Description:
Pump.io is a socially oriented federated network. It provides a way to post
notes and images as well and subscribe to other people to get updates on
what they post.

PyPump provides an interface to the pump.io API's. The aim is to provide
very natural pythonic representations of Notes, Images, People, etc...
allowing you to painlessly interact with them.
Comment 1 Mosaab Alzoubi 2013-11-05 17:21:46 EST
I'm not a packager yet, but these information may help.

-------------------------
Package PRE-Review :

* License GPLv3
* Using docs/ folder as documents in both python-pypump and python3-pypump without making them !
There are alot of choises :
  html       to make standalone HTML files
  dirhtml    to make HTML files named index.html in directories
  singlehtml to make a single large HTML file
  pickle     to make pickle files
  json       to make JSON files
  htmlhelp   to make HTML files and a HTML help project
  qthelp     to make HTML files and a qthelp project
  devhelp    to make HTML files and a Devhelp project
  epub       to make an epub
  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter
  latexpdf   to make LaTeX files and run them through pdflatex
  text       to make text files
  man        to make manual pages
  texinfo    to make Texinfo files
  info       to make Texinfo files and run them through makeinfo
  gettext    to make PO message catalogs
  changes    to make an overview of all changed/added/deprecated items
  linkcheck  to check all external links for integrity
  doctest    to run all doctests embedded in the documentation (if enabled)

That will be nice if some of them (html,man..) maked.

* Must use %__python2 macro instead of %__python.
* Source in SRPM match upstream one. 197a6bbb604edda02390f23bb7cc817a.
* Spec and contents is clean.
* Rpmlint almost clean :
rpmlint -i /run/media/moceap/MULTIBOOT/1025601-python-pypump/srpm/python-pypump-0.4-1.fc19.src.rpm
python-pypump.src: W: spelling-error Summary(en_US) io -> oi, Io, ii
The value of this tag appears to be misspelled. Please double-check.

python-pypump.src: W: spelling-error %description -l en_US io -> oi, Io, ii
The value of this tag appears to be misspelled. Please double-check.

python-pypump.src: W: spelling-error %description -l en_US pythonic -> Python, python
The value of this tag appears to be misspelled. Please double-check.

python-pypump.src: W: invalid-url URL: http://pypi.python.org/pypi/PyPump timed out
The value should be a valid, public HTTP, HTTPS, or FTP URL.

1 packages and 0 specfiles checked; 0 errors, 4 warnings.

* To solve URL warning use HTTPS instead HTTP.
* Builds succeed in Fedora 19 i686 (using updates-testing repo).
* No bundels.

==
Comment 2 Mario Blättermann 2013-11-08 13:50:13 EST
(In reply to Mosaab Alzoubi from comment #1)
> * License GPLv3

Have a look at this:

$ licensecheck -r *
docs/conf.py: GENERATED FILE
docs/examples/pypump-post-note.py: *No copyright* UNKNOWN
pypump/exception/PumpException.py: *No copyright* UNKNOWN
pypump/exception/DoesNotExist.py: *No copyright* UNKNOWN
pypump/exception/ImmutableException.py: *No copyright* UNKNOWN
pypump/exception/__init__.py: *No copyright* UNKNOWN
pypump/exception/ServerError.py: *No copyright* UNKNOWN
pypump/pypump.py: GPL (v3 or later)
pypump/__init__.py: *No copyright* UNKNOWN
pypump/models/comment.py: GPL (v3 or later)
pypump/models/image.py: GPL (v3 or later)
pypump/models/activity.py: GPL (v3 or later)
pypump/models/person.py: GPL (v3 or later)
pypump/models/feed.py: GPL (v3 or later)
pypump/models/__init__.py: GPL (v3 or later)
pypump/models/location.py: GPL (v3 or later)
pypump/models/collection.py: GPL (v3 or later)
pypump/models/note.py: GPL (v3 or later)
pypump/openid.py: GPL (v3 or later)
pypump/compatability.py: GPL (v3 or later)
setup.py: *No copyright* UNKNOWN

Don't refer to the license file only. In doubt, have a look at the file headers to see if the "later versions" clause has to be applied.

 
> * Using docs/ folder as documents in both python-pypump and python3-pypump
> without making them !

Indeed, the docs contain the "docs" folder as it is. If you want to add those contents to the package, proceed the Makefile to get real content.
 
> * Must use %__python2 macro instead of %__python.
See also https://bugzilla.redhat.com/show_bug.cgi?id=1025368#c1.
Comment 3 Ralph Bean 2013-12-17 11:32:46 EST
Mosaab, Mario, sorry for not responding sooner.  It was rude of me.

Here's an updated version of the spec and srpm based on your feedback.  I built the HTML docs, and used the appropriate python2 macro.

Spec Url: http://threebean.org/rpm/python-pypump.spec
SRPM Url: http://threebean.org/rpm/python-pypump-0.4-2.fc20.src.rpm
Comment 4 Mario Blättermann 2014-01-09 07:05:27 EST
Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=6378378

$ rpmlint -i -v *
python3-pypump.noarch: I: checking
python3-pypump.noarch: E: explicit-lib-dependency python-oauthlib
You must let rpm find the library dependencies by itself. Do not put unneeded
explicit Requires: tags.

python3-pypump.noarch: W: spelling-error Summary(en_US) io -> oi, Io, ii
The value of this tag appears to be misspelled. Please double-check.

python3-pypump.noarch: W: spelling-error %description -l en_US io -> oi, Io, ii
The value of this tag appears to be misspelled. Please double-check.

python3-pypump.noarch: W: spelling-error %description -l en_US pythonic -> Python, python
The value of this tag appears to be misspelled. Please double-check.

python3-pypump.noarch: I: checking-url http://pypi.python.org/pypi/PyPump (timeout 10 seconds)
python3-pypump.noarch: W: hidden-file-or-dir /usr/share/doc/python3-pypump/docs-html/.doctrees
The file or directory is hidden. You should see if this is normal, and delete
it from the package if not.

python3-pypump.noarch: W: hidden-file-or-dir /usr/share/doc/python3-pypump/docs-html/.doctrees
The file or directory is hidden. You should see if this is normal, and delete
it from the package if not.

python3-pypump.noarch: W: hidden-file-or-dir /usr/share/doc/python3-pypump/docs-html/.buildinfo
The file or directory is hidden. You should see if this is normal, and delete
it from the package if not.

python3-pypump.noarch: W: doc-file-dependency /usr/share/doc/python3-pypump/docs/examples/pypump-post-note.py /usr/bin/env
An included file marked as %doc creates a possible additional dependency in
the package.  Usually, this is not wanted and may be caused by eg. example
scripts with executable bits set included in the package's documentation.

python-pypump.src: I: checking
python-pypump.src: W: spelling-error Summary(en_US) io -> oi, Io, ii
The value of this tag appears to be misspelled. Please double-check.

python-pypump.src: W: spelling-error %description -l en_US io -> oi, Io, ii
The value of this tag appears to be misspelled. Please double-check.

python-pypump.src: W: spelling-error %description -l en_US pythonic -> Python, python
The value of this tag appears to be misspelled. Please double-check.

python-pypump.src: I: checking-url http://pypi.python.org/pypi/PyPump (timeout 10 seconds)
python-pypump.src: I: checking-url http://pypi.python.org/packages/source/P/PyPump/PyPump-0.4.tar.gz (timeout 10 seconds)
python-pypump.noarch: I: checking
python-pypump.noarch: E: explicit-lib-dependency python-oauthlib
You must let rpm find the library dependencies by itself. Do not put unneeded
explicit Requires: tags.

python-pypump.noarch: W: spelling-error Summary(en_US) io -> oi, Io, ii
The value of this tag appears to be misspelled. Please double-check.

python-pypump.noarch: W: spelling-error %description -l en_US io -> oi, Io, ii
The value of this tag appears to be misspelled. Please double-check.

python-pypump.noarch: W: spelling-error %description -l en_US pythonic -> Python, python
The value of this tag appears to be misspelled. Please double-check.

python-pypump.noarch: I: checking-url http://pypi.python.org/pypi/PyPump (timeout 10 seconds)
python-pypump.noarch: W: hidden-file-or-dir /usr/share/doc/python-pypump/docs-html/.doctrees
The file or directory is hidden. You should see if this is normal, and delete
it from the package if not.

python-pypump.noarch: W: hidden-file-or-dir /usr/share/doc/python-pypump/docs-html/.doctrees
The file or directory is hidden. You should see if this is normal, and delete
it from the package if not.

python-pypump.noarch: W: hidden-file-or-dir /usr/share/doc/python-pypump/docs-html/.buildinfo
The file or directory is hidden. You should see if this is normal, and delete
it from the package if not.

python-pypump.noarch: W: doc-file-dependency /usr/share/doc/python-pypump/docs/examples/pypump-post-note.py /usr/bin/env
An included file marked as %doc creates a possible additional dependency in
the package.  Usually, this is not wanted and may be caused by eg. example
scripts with executable bits set included in the package's documentation.

python-pypump.spec: I: checking-url http://pypi.python.org/packages/source/P/PyPump/PyPump-0.4.tar.gz (timeout 10 seconds)
3 packages and 1 specfiles checked; 2 errors, 17 warnings.


The explicit-library-dependency warning are false positive, python-oauthlib is noarch and that's why not a library in common sense.

Remove the executable bit from the example file.

Regarding the hidden files: The .doctree folder seems to mirror the whole docs structure again. Try to find out if it is really needed (or just an artifact from Sphinx) and remove it, if possible.
Comment 5 Mario Blättermann 2014-01-09 07:24:18 EST
Just found another issue:

$ rpm -qpR python3-pypump-0.4-2.fc21.noarch.rpm
/usr/bin/env
python(abi) = 3.3
python-dateutil
python-oauthlib
python-requests
rpmlib(CompressedFileNames) <= 3.0.4-1
rpmlib(FileDigests) <= 4.6.0-1
rpmlib(PartialHardlinkSets) <= 4.0.4-1
rpmlib(PayloadFilesHavePrefix) <= 4.0-1
rpmlib(PayloadIsXz) <= 5.2-1

The "Requires" listing is outside of the python3 condition. You have to include the runtime requirements there, applying the special needs for Python 3, otherwise I'm afraid the Python 3 version won't work.
Comment 6 Ralph Bean 2014-01-13 11:47:40 EST
Thanks Mario.  This release should take care of all those issues.

Spec Url: http://threebean.org/rpm/python-pypump.spec
SRPM Url: http://threebean.org/rpm/python-pypump-0.4-3.fc20.src.rpm
Comment 7 Mario Blättermann 2014-01-24 17:49:47 EST
Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=6451561

$ rpmlint -i -v *
python3-pypump.noarch: I: checking
python3-pypump.noarch: E: explicit-lib-dependency python3-oauthlib
You must let rpm find the library dependencies by itself. Do not put unneeded
explicit Requires: tags.

python3-pypump.noarch: W: spelling-error Summary(en_US) io -> oi, Io, ii
The value of this tag appears to be misspelled. Please double-check.

python3-pypump.noarch: W: spelling-error %description -l en_US io -> oi, Io, ii
The value of this tag appears to be misspelled. Please double-check.

python3-pypump.noarch: W: spelling-error %description -l en_US pythonic -> Python, python
The value of this tag appears to be misspelled. Please double-check.

python3-pypump.noarch: I: checking-url http://pypi.python.org/pypi/PyPump (timeout 10 seconds)
python-pypump.src: I: checking
python-pypump.src: W: spelling-error Summary(en_US) io -> oi, Io, ii
The value of this tag appears to be misspelled. Please double-check.

python-pypump.src: W: spelling-error %description -l en_US io -> oi, Io, ii
The value of this tag appears to be misspelled. Please double-check.

python-pypump.src: W: spelling-error %description -l en_US pythonic -> Python, python
The value of this tag appears to be misspelled. Please double-check.

python-pypump.src: I: checking-url http://pypi.python.org/pypi/PyPump (timeout 10 seconds)
python-pypump.src: I: checking-url http://pypi.python.org/packages/source/P/PyPump/PyPump-0.4.tar.gz (timeout 10 seconds)
python-pypump.noarch: I: checking
python-pypump.noarch: E: explicit-lib-dependency python-oauthlib
You must let rpm find the library dependencies by itself. Do not put unneeded
explicit Requires: tags.

python-pypump.noarch: W: spelling-error Summary(en_US) io -> oi, Io, ii
The value of this tag appears to be misspelled. Please double-check.

python-pypump.noarch: W: spelling-error %description -l en_US io -> oi, Io, ii
The value of this tag appears to be misspelled. Please double-check.

python-pypump.noarch: W: spelling-error %description -l en_US pythonic -> Python, python
The value of this tag appears to be misspelled. Please double-check.

python-pypump.noarch: I: checking-url http://pypi.python.org/pypi/PyPump (timeout 10 seconds)
python-pypump.spec: I: checking-url http://pypi.python.org/packages/source/P/PyPump/PyPump-0.4.tar.gz (timeout 10 seconds)
3 packages and 1 specfiles checked; 2 errors, 9 warnings.

Already discussed issues, no new ones so far.


---------------------------------
key:

[+] OK
[.] OK, not applicable
[X] needs work
---------------------------------

[+] MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.
[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
[+] MUST: The package must meet the Packaging Guidelines.
[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
[+] MUST: The License field in the package spec file must match the actual license.
    MIT
[+] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use sha256sum for this task as it is used by the sources file once imported into git. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
    $ sha256sum *
    1e64f66888e57724adc834ffe9619acd2fbc5a44b5ec7cf615e2b03dbc6f0a81  PyPump-0.4.tar.gz
    1e64f66888e57724adc834ffe9619acd2fbc5a44b5ec7cf615e2b03dbc6f0a81  PyPump-0.4.tar.gz.orig

[+] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
[.] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
[+] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[.] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[.] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
[.] MUST: Packages must NOT bundle copies of system libraries.
[.] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
[+] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
[+] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
[+] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example.
[+] MUST: Each package must consistently use macros.
[+] MUST: The package must contain code, or permissable content.
[.] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
[+] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
[.] MUST: Static libraries must be in a -static package.
[.] MUST: Development files must be in a -devel package.
[.] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release}
[.] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
[.] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
[+] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. 
[+] MUST: All filenames in rpm packages must be valid UTF-8.


[.] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[.] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[+] SHOULD: The reviewer should test that the package builds in mock.
    See Koji build above (which uses Mock anyway).
[+] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[.] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[.] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[.] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[.] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
[.] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
[+] SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.


----------------

PACKAGE APPROVED

----------------
Comment 8 Ralph Bean 2014-01-24 18:32:34 EST
New Package SCM Request
=======================
Package Name: python-pypump
Short Description: Python Pump.io library
Owners: ralph
Branches: f20 f19 el6 epel7
InitialCC:
Comment 9 Gwyn Ciesla 2014-01-27 08:09:52 EST
Git done (by process-git-requests).
Comment 10 Fedora Update System 2014-01-27 10:35:27 EST
python-pypump-0.4-3.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/python-pypump-0.4-3.fc20
Comment 11 Fedora Update System 2014-01-27 10:35:52 EST
python-pypump-0.4-3.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/python-pypump-0.4-3.fc19
Comment 12 Fedora Update System 2014-02-18 08:41:53 EST
python-pypump-0.4-3.fc19 has been pushed to the Fedora 19 stable repository.
Comment 13 Fedora Update System 2014-02-18 08:46:13 EST
python-pypump-0.4-3.fc20 has been pushed to the Fedora 20 stable repository.

Note You need to log in before you can comment on or make changes to this bug.